//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransaction_h
#define PWebAuthnTransaction_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnAuthenticatorSelection|
//
namespace mozilla {
namespace dom {
class WebAuthnAuthenticatorSelection final
{
private:

public:
    MOZ_IMPLICIT WebAuthnAuthenticatorSelection();

    MOZ_IMPLICIT WebAuthnAuthenticatorSelection(
            const bool& _requireResidentKey,
            const bool& _requireUserVerification,
            const bool& _requirePlatformAttachment)
    {
        Init();
        Assign(_requireResidentKey, _requireUserVerification, _requirePlatformAttachment);
    }

    MOZ_IMPLICIT WebAuthnAuthenticatorSelection(const WebAuthnAuthenticatorSelection& _o)
    {
        Init();
        Assign((_o).requireResidentKey(), (_o).requireUserVerification(), (_o).requirePlatformAttachment());
    }

    ~WebAuthnAuthenticatorSelection();

    void
    operator=(const WebAuthnAuthenticatorSelection& _o)
    {
        Assign((_o).requireResidentKey(), (_o).requireUserVerification(), (_o).requirePlatformAttachment());
    }

    bool
    operator==(const WebAuthnAuthenticatorSelection& _o) const;

    bool
    operator!=(const WebAuthnAuthenticatorSelection& _o) const;

    bool&
    requireResidentKey()
    {
        return requireResidentKey_;
    }
    const bool&
    requireResidentKey() const
    {
        return requireResidentKey_;
    }

    bool&
    requireUserVerification()
    {
        return requireUserVerification_;
    }
    const bool&
    requireUserVerification() const
    {
        return requireUserVerification_;
    }

    bool&
    requirePlatformAttachment()
    {
        return requirePlatformAttachment_;
    }
    const bool&
    requirePlatformAttachment() const
    {
        return requirePlatformAttachment_;
    }

private:
    void
    Init();

    void
    Assign(
            const bool& _requireResidentKey,
            const bool& _requireUserVerification,
            const bool& _requirePlatformAttachment);

    bool requireResidentKey_;
    bool requireUserVerification_;
    bool requirePlatformAttachment_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnScopedCredential|
//
namespace mozilla {
namespace dom {
class WebAuthnScopedCredential final
{
private:

public:
    MOZ_IMPLICIT WebAuthnScopedCredential();

    MOZ_IMPLICIT WebAuthnScopedCredential(
            const nsTArray<uint8_t>& _id,
            const uint8_t& _transports)
    {
        Init();
        Assign(_id, _transports);
    }

    MOZ_IMPLICIT WebAuthnScopedCredential(const WebAuthnScopedCredential& _o)
    {
        Init();
        Assign((_o).id(), (_o).transports());
    }

    ~WebAuthnScopedCredential();

    void
    operator=(const WebAuthnScopedCredential& _o)
    {
        Assign((_o).id(), (_o).transports());
    }

    bool
    operator==(const WebAuthnScopedCredential& _o) const;

    bool
    operator!=(const WebAuthnScopedCredential& _o) const;

    nsTArray<uint8_t>&
    id()
    {
        return id_;
    }
    const nsTArray<uint8_t>&
    id() const
    {
        return id_;
    }

    uint8_t&
    transports()
    {
        return transports_;
    }
    const uint8_t&
    transports() const
    {
        return transports_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _id,
            const uint8_t& _transports);

    nsTArray<uint8_t> id_;
    uint8_t transports_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnExtensionAppId|
//
namespace mozilla {
namespace dom {
class WebAuthnExtensionAppId final
{
private:

public:
    MOZ_IMPLICIT WebAuthnExtensionAppId();

    MOZ_IMPLICIT WebAuthnExtensionAppId(const nsTArray<uint8_t>& _AppId)
    {
        Init();
        Assign(_AppId);
    }

    MOZ_IMPLICIT WebAuthnExtensionAppId(const WebAuthnExtensionAppId& _o)
    {
        Init();
        Assign((_o).AppId());
    }

    ~WebAuthnExtensionAppId();

    void
    operator=(const WebAuthnExtensionAppId& _o)
    {
        Assign((_o).AppId());
    }

    bool
    operator==(const WebAuthnExtensionAppId& _o) const;

    bool
    operator!=(const WebAuthnExtensionAppId& _o) const;

    nsTArray<uint8_t>&
    AppId()
    {
        return AppId_;
    }
    const nsTArray<uint8_t>&
    AppId() const
    {
        return AppId_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<uint8_t>& _AppId);

    nsTArray<uint8_t> AppId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class WebAuthnExtensionAppId;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebAuthnExtension|
//
namespace mozilla {
namespace dom {
class WebAuthnExtension final
{
public:
    enum Type {
        T__None,
        TWebAuthnExtensionAppId = 1,
        T__Last = TWebAuthnExtensionAppId
    };

private:
    typedef mozilla::dom::WebAuthnExtensionAppId WebAuthnExtensionAppId;
    typedef WebAuthnExtensionAppId WebAuthnExtensionAppId__tdef;

    union Value {
        mozilla::AlignedStorage2<WebAuthnExtensionAppId> VWebAuthnExtensionAppId;
    };

    WebAuthnExtensionAppId*
    ptr_WebAuthnExtensionAppId()
    {
        return ((mValue).VWebAuthnExtensionAppId).addr();
    }
    const WebAuthnExtensionAppId*
    constptr_WebAuthnExtensionAppId() const
    {
        return ((mValue).VWebAuthnExtensionAppId).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebAuthnExtension() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebAuthnExtension(const WebAuthnExtensionAppId& aOther);

    MOZ_IMPLICIT WebAuthnExtension(const WebAuthnExtension& aOther);

    ~WebAuthnExtension();

    Type
    type() const
    {
        return mType;
    }

    WebAuthnExtension&
    operator=(const WebAuthnExtensionAppId& aRhs);

    WebAuthnExtension&
    operator=(const WebAuthnExtension& aRhs);

    bool
    operator==(const WebAuthnExtensionAppId& aRhs) const;

    bool
    operator==(const WebAuthnExtension& aRhs) const;

    WebAuthnExtensionAppId&
    get_WebAuthnExtensionAppId()
    {
        AssertSanity(TWebAuthnExtensionAppId);
        return (*(ptr_WebAuthnExtensionAppId()));
    }
    const WebAuthnExtensionAppId&
    get_WebAuthnExtensionAppId() const
    {
        AssertSanity(TWebAuthnExtensionAppId);
        return (*(constptr_WebAuthnExtensionAppId()));
    }
    void
    get(WebAuthnExtensionAppId* aOutValue) const;
    operator WebAuthnExtensionAppId&()
    {
        return get_WebAuthnExtensionAppId();
    }
    operator const WebAuthnExtensionAppId&() const
    {
        return get_WebAuthnExtensionAppId();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnExtensionResultAppId|
//
namespace mozilla {
namespace dom {
class WebAuthnExtensionResultAppId final
{
private:

public:
    MOZ_IMPLICIT WebAuthnExtensionResultAppId();

    MOZ_IMPLICIT WebAuthnExtensionResultAppId(const bool& _AppId)
    {
        Init();
        Assign(_AppId);
    }

    MOZ_IMPLICIT WebAuthnExtensionResultAppId(const WebAuthnExtensionResultAppId& _o)
    {
        Init();
        Assign((_o).AppId());
    }

    ~WebAuthnExtensionResultAppId();

    void
    operator=(const WebAuthnExtensionResultAppId& _o)
    {
        Assign((_o).AppId());
    }

    bool
    operator==(const WebAuthnExtensionResultAppId& _o) const;

    bool
    operator!=(const WebAuthnExtensionResultAppId& _o) const;

    bool&
    AppId()
    {
        return AppId_;
    }
    const bool&
    AppId() const
    {
        return AppId_;
    }

private:
    void
    Init();

    void
    Assign(const bool& _AppId);

    bool AppId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class WebAuthnExtensionResultAppId;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebAuthnExtensionResult|
//
namespace mozilla {
namespace dom {
class WebAuthnExtensionResult final
{
public:
    enum Type {
        T__None,
        TWebAuthnExtensionResultAppId = 1,
        T__Last = TWebAuthnExtensionResultAppId
    };

private:
    typedef mozilla::dom::WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId;
    typedef WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId__tdef;

    union Value {
        mozilla::AlignedStorage2<WebAuthnExtensionResultAppId> VWebAuthnExtensionResultAppId;
    };

    WebAuthnExtensionResultAppId*
    ptr_WebAuthnExtensionResultAppId()
    {
        return ((mValue).VWebAuthnExtensionResultAppId).addr();
    }
    const WebAuthnExtensionResultAppId*
    constptr_WebAuthnExtensionResultAppId() const
    {
        return ((mValue).VWebAuthnExtensionResultAppId).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebAuthnExtensionResult() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebAuthnExtensionResult(const WebAuthnExtensionResultAppId& aOther);

    MOZ_IMPLICIT WebAuthnExtensionResult(const WebAuthnExtensionResult& aOther);

    ~WebAuthnExtensionResult();

    Type
    type() const
    {
        return mType;
    }

    WebAuthnExtensionResult&
    operator=(const WebAuthnExtensionResultAppId& aRhs);

    WebAuthnExtensionResult&
    operator=(const WebAuthnExtensionResult& aRhs);

    bool
    operator==(const WebAuthnExtensionResultAppId& aRhs) const;

    bool
    operator==(const WebAuthnExtensionResult& aRhs) const;

    WebAuthnExtensionResultAppId&
    get_WebAuthnExtensionResultAppId()
    {
        AssertSanity(TWebAuthnExtensionResultAppId);
        return (*(ptr_WebAuthnExtensionResultAppId()));
    }
    const WebAuthnExtensionResultAppId&
    get_WebAuthnExtensionResultAppId() const
    {
        AssertSanity(TWebAuthnExtensionResultAppId);
        return (*(constptr_WebAuthnExtensionResultAppId()));
    }
    void
    get(WebAuthnExtensionResultAppId* aOutValue) const;
    operator WebAuthnExtensionResultAppId&()
    {
        return get_WebAuthnExtensionResultAppId();
    }
    operator const WebAuthnExtensionResultAppId&() const
    {
        return get_WebAuthnExtensionResultAppId();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class WebAuthnScopedCredential;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class WebAuthnExtension;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class WebAuthnAuthenticatorSelection;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnMakeCredentialInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnMakeCredentialInfo final
{
private:
    typedef mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef mozilla::dom::WebAuthnAuthenticatorSelection WebAuthnAuthenticatorSelection;

public:
    MOZ_IMPLICIT WebAuthnMakeCredentialInfo();

    MOZ_IMPLICIT WebAuthnMakeCredentialInfo(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _ClientDataHash,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredential>& _ExcludeList,
            const nsTArray<WebAuthnExtension>& _Extensions,
            const WebAuthnAuthenticatorSelection& _AuthenticatorSelection)
    {
        Init();
        Assign(_RpIdHash, _ClientDataHash, _TimeoutMS, _ExcludeList, _Extensions, _AuthenticatorSelection);
    }

    MOZ_IMPLICIT WebAuthnMakeCredentialInfo(const WebAuthnMakeCredentialInfo& _o)
    {
        Init();
        Assign((_o).RpIdHash(), (_o).ClientDataHash(), (_o).TimeoutMS(), (_o).ExcludeList(), (_o).Extensions(), (_o).AuthenticatorSelection());
    }

    ~WebAuthnMakeCredentialInfo();

    void
    operator=(const WebAuthnMakeCredentialInfo& _o)
    {
        Assign((_o).RpIdHash(), (_o).ClientDataHash(), (_o).TimeoutMS(), (_o).ExcludeList(), (_o).Extensions(), (_o).AuthenticatorSelection());
    }

    bool
    operator==(const WebAuthnMakeCredentialInfo& _o) const;

    bool
    operator!=(const WebAuthnMakeCredentialInfo& _o) const;

    nsTArray<uint8_t>&
    RpIdHash()
    {
        return RpIdHash_;
    }
    const nsTArray<uint8_t>&
    RpIdHash() const
    {
        return RpIdHash_;
    }

    nsTArray<uint8_t>&
    ClientDataHash()
    {
        return ClientDataHash_;
    }
    const nsTArray<uint8_t>&
    ClientDataHash() const
    {
        return ClientDataHash_;
    }

    uint32_t&
    TimeoutMS()
    {
        return TimeoutMS_;
    }
    const uint32_t&
    TimeoutMS() const
    {
        return TimeoutMS_;
    }

    nsTArray<WebAuthnScopedCredential>&
    ExcludeList()
    {
        return ExcludeList_;
    }
    const nsTArray<WebAuthnScopedCredential>&
    ExcludeList() const
    {
        return ExcludeList_;
    }

    nsTArray<WebAuthnExtension>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtension>&
    Extensions() const
    {
        return Extensions_;
    }

    WebAuthnAuthenticatorSelection&
    AuthenticatorSelection()
    {
        return AuthenticatorSelection_;
    }
    const WebAuthnAuthenticatorSelection&
    AuthenticatorSelection() const
    {
        return AuthenticatorSelection_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _ClientDataHash,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredential>& _ExcludeList,
            const nsTArray<WebAuthnExtension>& _Extensions,
            const WebAuthnAuthenticatorSelection& _AuthenticatorSelection);

    nsTArray<uint8_t> RpIdHash_;
    nsTArray<uint8_t> ClientDataHash_;
    uint32_t TimeoutMS_;
    nsTArray<WebAuthnScopedCredential> ExcludeList_;
    nsTArray<WebAuthnExtension> Extensions_;
    WebAuthnAuthenticatorSelection AuthenticatorSelection_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnMakeCredentialResult|
//
namespace mozilla {
namespace dom {
class WebAuthnMakeCredentialResult final
{
private:

public:
    MOZ_IMPLICIT WebAuthnMakeCredentialResult();

    MOZ_IMPLICIT WebAuthnMakeCredentialResult(const nsTArray<uint8_t>& _RegBuffer)
    {
        Init();
        Assign(_RegBuffer);
    }

    MOZ_IMPLICIT WebAuthnMakeCredentialResult(const WebAuthnMakeCredentialResult& _o)
    {
        Init();
        Assign((_o).RegBuffer());
    }

    ~WebAuthnMakeCredentialResult();

    void
    operator=(const WebAuthnMakeCredentialResult& _o)
    {
        Assign((_o).RegBuffer());
    }

    bool
    operator==(const WebAuthnMakeCredentialResult& _o) const;

    bool
    operator!=(const WebAuthnMakeCredentialResult& _o) const;

    nsTArray<uint8_t>&
    RegBuffer()
    {
        return RegBuffer_;
    }
    const nsTArray<uint8_t>&
    RegBuffer() const
    {
        return RegBuffer_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<uint8_t>& _RegBuffer);

    nsTArray<uint8_t> RegBuffer_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class WebAuthnScopedCredential;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class WebAuthnExtension;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnGetAssertionInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnGetAssertionInfo final
{
private:
    typedef mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;

public:
    MOZ_IMPLICIT WebAuthnGetAssertionInfo();

    MOZ_IMPLICIT WebAuthnGetAssertionInfo(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _ClientDataHash,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredential>& _AllowList,
            const bool& _RequireUserVerification,
            const nsTArray<WebAuthnExtension>& _Extensions)
    {
        Init();
        Assign(_RpIdHash, _ClientDataHash, _TimeoutMS, _AllowList, _RequireUserVerification, _Extensions);
    }

    MOZ_IMPLICIT WebAuthnGetAssertionInfo(const WebAuthnGetAssertionInfo& _o)
    {
        Init();
        Assign((_o).RpIdHash(), (_o).ClientDataHash(), (_o).TimeoutMS(), (_o).AllowList(), (_o).RequireUserVerification(), (_o).Extensions());
    }

    ~WebAuthnGetAssertionInfo();

    void
    operator=(const WebAuthnGetAssertionInfo& _o)
    {
        Assign((_o).RpIdHash(), (_o).ClientDataHash(), (_o).TimeoutMS(), (_o).AllowList(), (_o).RequireUserVerification(), (_o).Extensions());
    }

    bool
    operator==(const WebAuthnGetAssertionInfo& _o) const;

    bool
    operator!=(const WebAuthnGetAssertionInfo& _o) const;

    nsTArray<uint8_t>&
    RpIdHash()
    {
        return RpIdHash_;
    }
    const nsTArray<uint8_t>&
    RpIdHash() const
    {
        return RpIdHash_;
    }

    nsTArray<uint8_t>&
    ClientDataHash()
    {
        return ClientDataHash_;
    }
    const nsTArray<uint8_t>&
    ClientDataHash() const
    {
        return ClientDataHash_;
    }

    uint32_t&
    TimeoutMS()
    {
        return TimeoutMS_;
    }
    const uint32_t&
    TimeoutMS() const
    {
        return TimeoutMS_;
    }

    nsTArray<WebAuthnScopedCredential>&
    AllowList()
    {
        return AllowList_;
    }
    const nsTArray<WebAuthnScopedCredential>&
    AllowList() const
    {
        return AllowList_;
    }

    bool&
    RequireUserVerification()
    {
        return RequireUserVerification_;
    }
    const bool&
    RequireUserVerification() const
    {
        return RequireUserVerification_;
    }

    nsTArray<WebAuthnExtension>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtension>&
    Extensions() const
    {
        return Extensions_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _ClientDataHash,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredential>& _AllowList,
            const bool& _RequireUserVerification,
            const nsTArray<WebAuthnExtension>& _Extensions);

    nsTArray<uint8_t> RpIdHash_;
    nsTArray<uint8_t> ClientDataHash_;
    uint32_t TimeoutMS_;
    nsTArray<WebAuthnScopedCredential> AllowList_;
    bool RequireUserVerification_;
    nsTArray<WebAuthnExtension> Extensions_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class WebAuthnExtensionResult;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnGetAssertionResult|
//
namespace mozilla {
namespace dom {
class WebAuthnGetAssertionResult final
{
private:
    typedef mozilla::dom::WebAuthnExtensionResult WebAuthnExtensionResult;

public:
    MOZ_IMPLICIT WebAuthnGetAssertionResult();

    MOZ_IMPLICIT WebAuthnGetAssertionResult(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _CredentialID,
            const nsTArray<uint8_t>& _SigBuffer,
            const nsTArray<WebAuthnExtensionResult>& _Extensions)
    {
        Init();
        Assign(_RpIdHash, _CredentialID, _SigBuffer, _Extensions);
    }

    MOZ_IMPLICIT WebAuthnGetAssertionResult(const WebAuthnGetAssertionResult& _o)
    {
        Init();
        Assign((_o).RpIdHash(), (_o).CredentialID(), (_o).SigBuffer(), (_o).Extensions());
    }

    ~WebAuthnGetAssertionResult();

    void
    operator=(const WebAuthnGetAssertionResult& _o)
    {
        Assign((_o).RpIdHash(), (_o).CredentialID(), (_o).SigBuffer(), (_o).Extensions());
    }

    bool
    operator==(const WebAuthnGetAssertionResult& _o) const;

    bool
    operator!=(const WebAuthnGetAssertionResult& _o) const;

    nsTArray<uint8_t>&
    RpIdHash()
    {
        return RpIdHash_;
    }
    const nsTArray<uint8_t>&
    RpIdHash() const
    {
        return RpIdHash_;
    }

    nsTArray<uint8_t>&
    CredentialID()
    {
        return CredentialID_;
    }
    const nsTArray<uint8_t>&
    CredentialID() const
    {
        return CredentialID_;
    }

    nsTArray<uint8_t>&
    SigBuffer()
    {
        return SigBuffer_;
    }
    const nsTArray<uint8_t>&
    SigBuffer() const
    {
        return SigBuffer_;
    }

    nsTArray<WebAuthnExtensionResult>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtensionResult>&
    Extensions() const
    {
        return Extensions_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _CredentialID,
            const nsTArray<uint8_t>& _SigBuffer,
            const nsTArray<WebAuthnExtensionResult>& _Extensions);

    nsTArray<uint8_t> RpIdHash_;
    nsTArray<uint8_t> CredentialID_;
    nsTArray<uint8_t> SigBuffer_;
    nsTArray<WebAuthnExtensionResult> Extensions_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PWebAuthnTransactionParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PWebAuthnTransactionChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PWebAuthnTransactionChild and PWebAuthnTransactionParent
//
namespace mozilla {
namespace dom {
namespace PWebAuthnTransaction {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PWebAuthnTransactionParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PWebAuthnTransactionChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PWebAuthnTransactionStart = PWebAuthnTransactionMsgStart << 16,
    Msg_RequestRegister__ID,
    Msg_RequestSign__ID,
    Msg_RequestCancel__ID,
    Msg_DestroyMe__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ConfirmRegister__ID,
    Msg_ConfirmSign__ID,
    Msg_Abort__ID,
    PWebAuthnTransactionEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg_RequestRegister(int32_t routingId);

IPC::Message*
Msg_RequestSign(int32_t routingId);

IPC::Message*
Msg_RequestCancel(int32_t routingId);

IPC::Message*
Msg_DestroyMe(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_ConfirmRegister(int32_t routingId);

IPC::Message*
Msg_ConfirmSign(int32_t routingId);

IPC::Message*
Msg_Abort(int32_t routingId);



} // namespace PWebAuthnTransaction
} // namespace dom
} // namespace mozilla

#endif // ifndef PWebAuthnTransaction_h
